/* functions.c
 *
 *  ``pinfocom'' -- a portable Infocom Inc. data file interpreter.
 *  Copyright (C) 1987-1992  InfoTaskForce
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; see the file COPYING.  If not, write to the
 *  Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * $Header: RCS/funcs.c,v 3.0 1992/10/21 16:56:19 pds Stab $
 */

#include    "infocom.h"

extern word param[];
extern word num_params;

void
plus(void)
{
    store(param[0] + param[1]);
}

void
minus(void)
{
    store(param[0] - param[1]);
}

void
multiply(void)
{
    store(param[0] * param[1]);
}

void
divide(void)
{
    store(param[0] / param[1]);
}

void
mod(void)
{
    store(param[0] % param[1]);
}

void
pi_random ()
{
    extern word     random1;
    extern word     random2;
    extern word     param[];

    word            temp;

    temp = random1 << 1;
    random1 = random2;
    if (random2 & 0x8000)
        ++temp;
    random2 ^= temp;

    if (param[0])
        store(((word)(random2 & 0x7FFF) % param[0]) + 1);
    else
        store(0);
}

void
LTE(void)
{
    ret_value((signed_word)param[0] < (signed_word)param[1]);
}

void
GTE(void)
{
    ret_value((signed_word)param[0] > (signed_word)param[1]);
}

void
bit(void)
{
    ret_value((param[1] & (~param[0])) == 0);
}

void
or(void)
{
    store(param[0] | param[1]);
}

void
not(void)
{
    store(~param[0]);
}

void
and(void)
{
    store(param[0] & param[1]);
}

void
compare(void)
{
    const word *pp;
    Bool equal = 0;

    for (pp = &param[1]; num_params > 1; ++pp, --num_params)
        equal |= (param[0] == *pp);

    ret_value(equal);
}

void cp_zero(void)
{
   ret_value(param[0]==0);
}
