/* interp.c
 *
 *  ``pinfocom'' -- a portable Infocom Inc. data file interpreter.
 *  Copyright (C) 1987-1992  InfoTaskForce
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; see the file COPYING.  If not, write to the
 *  Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * $Header: RCS/interp.c,v 3.0 1992/10/21 16:56:19 pds Stab $
 */

#include <stdio.h>
#define NO_SIGNALS
#ifndef NO_SIGNALS
#include <signal.h>
#endif

#include "infocom.h"

/* ORIC PORT: the next externs are to call directly
 * some trivial functions instead of going through funcs.c
 */ 
extern word *stack;
extern word pc_offset;

/* ORIC PORT: We'll have opcode and parameters as global variables
 */
word param[4]; 
word opcode;
word num_params;

void invalid(void)
{
	printf("invalid opcode !");
	exit(1);
}

void unimplemented(void)
{}

void (*op1tab[])()={
	cp_zero, get_link, get_holds, get_loc, get_prop_len, inc_var, dec_var, print1,
	invalid, remove_obj, p_obj, rtn, jump, print2, get_var, not
};

void (*op2tab[])()={
	invalid, compare, LTE, GTE, dec_chk, inc_chk, check_loc, bit,
	or, and, test_attr, set_attr, clr_attr, put_var, transfer, load_word_array,
	load_byte_array, get_prop, get_prop_addr, next_prop, plus, minus, multiply, divide,
	mod, invalid, invalid, invalid, invalid, invalid, invalid, invalid,
	gosub, save_word_array, save_byte_array, put_prop, input, print_char, print_num, pi_random,
	push, pop, invalid, invalid, invalid, invalid, invalid, invalid,
	invalid, invalid, invalid, unimplemented, unimplemented, bell, invalid, invalid, 
	invalid, invalid, invalid, invalid, invalid, invalid, invalid, invalid, 
};

void (*misctab[])()={
	rtn1, rtn0, wrt, writeln, invalid, save, restore, restart,
	rts, pop_stack, quit, new_line, set_score, invalid, invalid, invalid
};


static void
oper3 ()
{
    register word    *pp;
    register word    np;
    register byte    modes;
    register int     addr_mode;
    register int     i;

    modes=NEXT_BYTE();
    np = 0;

    for (i=6, pp=param; i >= 0; ++pp, i-=2)
    {
        addr_mode = (modes >> i) & 0x03;
        if (addr_mode == 3)
            break;

        ++np;
        *pp = load(addr_mode);
    }

    for (; i >= 0; ++pp, i-=2)
        *pp = 0;
	 
    num_params=np;
    (*op2tab[opcode&0x3F])();
}

void
interp()
{  
extern word pc_offset;
    while (gflags.game_state != QUIT_GAME)
    {
	opcode=NEXT_BYTE();

        if (opcode < 0x80) {
	    param[0] = load( 1 + ((opcode & 0x40) != 0));
	    param[1] = load( 1 + ((opcode & 0x20) != 0));
	    num_params=2;
	    (*op2tab[opcode&0x1F])();
	} else if (opcode >= 0xC0) oper3();
        else if (opcode < 0xb0) {
    		param[0] = load((opcode >> 4) & 0x03);
          	(*op1tab[opcode&0x0F])();
        } else (*misctab[opcode&0x0F])();
    }
}
