/* object.c
 *
 *  ``pinfocom'' -- a portable Infocom Inc. data file interpreter.
 *  Copyright (C) 1987-1992  InfoTaskForce
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; see the file COPYING.  If not, write to the
 *  Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * $Header: RCS/object.c,v 3.0 1992/10/21 16:56:19 pds Stab $
 */


#include "infocom.h"
extern   word      param[];
    
static void
cut_obj (object_t * obj, word obj_num)
{
    register object_t *op;

    if (!obj->parent)
        return;

    op = obj_addr(obj->parent);

    if (op->child == obj_num)
        op->child = obj->sibling;
    else
    {
        op = obj_addr(op->child);
        while (op->sibling != obj_num)
            op = obj_addr(op->sibling);
        op->sibling = obj->sibling;
    }
    obj->parent = 0;
    obj->sibling = 0;
}

void
transfer ()
{
    register object_t  *obj1;
    register object_t  *obj2;

    obj1 = obj_addr(param[0]);
    obj2 = obj_addr(param[1]);

    cut_obj(obj1, param[0]);

    obj1->sibling = obj2->child;
    obj1->parent  = param[1];
    obj2->child   = param[0];
}

void
remove_obj ()
{
    register object_t  *obj;
   
    obj = obj_addr(param[0]);
    cut_obj(obj, param[0]);   
}

void
test_attr ()
{
    object_t    *obj;
    register int         b;
    register int         i;
    

    obj = obj_addr(param[0]);
    b = 0x80;
    for (i = param[1] % 8; i > 0; --i)
        b >>= 1;
    ret_value((obj->attributes[param[1] / 8] & b) != 0);
}

void
set_attr ()
{
    object_t    *obj;
    register int         b;
    register int         i;

    obj = obj_addr(param[0]);
    b = 0x80;
    for (i = param[1] % 8; i > 0; --i)
        b >>= 1;
    obj->attributes[param[1] / 8] |= b;
}

void
clr_attr ()
{
    object_t    *obj;
    register int         b;
    register int         i;

    obj = obj_addr(param[0]);
    b = 0x80;
    for (i = param[1] % 8; i > 0; --i)
        b >>= 1;
    obj->attributes[param[1] / 8] &= (~b);
}

void
get_loc ()
{
    register object_t *obj;

    obj = obj_addr(param[0]);
    store((word)obj->parent);
}

void
get_holds ()
{
    register object_t *obj;

    obj = obj_addr(param[0]);
    store((word)obj->child);
    ret_value(obj->child != 0);
}

void
get_link ()
{
    register object_t *obj;

    obj = obj_addr(param[0]);
    store((word)obj->sibling);
    ret_value(obj->sibling != 0);
}

void
check_loc ()
{
    register object_t *obj;

    obj = obj_addr(param[0]);
    ret_value(obj->parent == param[1]);
}

object_t *
obj_addr (word o)
{
    return (object_t *)(objd.obj_base+(o*objd.obj_size)+objd.obj_offset);
}
