/* variable.c
 *
 *  ``pinfocom'' -- a portable Infocom Inc. data file interpreter.
 *  Copyright (C) 1987-1992  InfoTaskForce
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; see the file COPYING.  If not, write to the
 *  Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * $Header: RCS/variable.c,v 3.0 1992/10/21 16:56:19 pds Stab $
 */

#include    "infocom.h"

extern word param[];

void
get_var(void)
{
    store(load_var(param[0]));
}

word
load_var (word var)
{
    extern byte     *global_ptr;
    extern word     *stack_var_ptr;
    extern word     *stack;

    byte            *ptr;
    word             res;
   
    if (var == 0)
        return (*stack);
    else if (var < LOCAL_VARS)
            return (*(stack_var_ptr - (var - 1)));
    else {
	    ptr = global_ptr + ((var - LOCAL_VARS) << 1);
	    res=Z_TO_WORD(ptr);
            return (res);
    }
}

void
put_var (void)
{
    extern byte     *global_ptr;
    extern word     *stack_var_ptr;
    extern word     *stack;

    word            *svp;
    byte            *ptr;

    if (param[0] == 0)
        *stack = param[1];
    else
    {
        if (param[0] < LOCAL_VARS)
        {
            svp = stack_var_ptr - (param[0] - 1);
            *svp = param[1];
        }
        else
        {
		    ptr = global_ptr + ((param[0] - LOCAL_VARS) << 1);
            *ptr++ = param[1] >> 8;
            *ptr = param[1];
        }
    }
}

void
push(void)
{
    extern word     *stack;

    *(--stack) = param[0];
}

void
pop(void)
{
    extern word     *stack;

    param[1]= *stack++;
    put_var();
}

void
inc_var(void)
{
    param[1]=load_var(param[0]) + 1;
    put_var();
}

void
dec_var(void)
{
    param[1]=load_var(param[0]) - 1;
    put_var();
}

void
inc_chk ()
{
    register word    value;
    extern   word    param[];
    register word    var=param[0];
    register word    threshold=param[1];

    param[1] = value = load_var(var) + 1;
    put_var();
    if ((signed_word)value > (signed_word)threshold)
        ret_value(1);
    else
        ret_value(0);
}

void
dec_chk ()
{
    register word    value;
    extern   word    param[];
    register word    var=param[0];
    register word    threshold=param[1];

    param[1] = value = load_var(var) - 1;
    put_var();
    if ((signed_word)value < (signed_word)threshold)
        ret_value(1);
    else
        ret_value(0);
}

word
load (int mode)
{
    extern word     *stack;

    register word            var;

    /*
     * Mode 0 = Immediate Word;
     * Mode 1 = Immediate Byte;
     * Mode 2 = Variable;
     */

    --mode;
    if (mode < 0)
        return (next_word());
    if (mode == 0)
	 return ((word)NEXT_BYTE());

    var=NEXT_BYTE();

    if (var == 0)
        return (*stack++);
    else
        return (load_var(var));
}
